/*
 *	fs.cc
 */

/*	Copyright (C) 1999, 2000, 2001 Sebastian Biallas (sb@web-productions.de)
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License version 2 as
 *	published by the Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License
 *	along with this program; if not, write to the Free Software
 *	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include "global.h"
#include "fs.h"
#include "tools.h"


/*
 *	fstrXXX procs and func are used for efficient string-storage
 */
struct strnode {
	strnode   	*left;
	strnode   	*right;
	char			*str;
	int			id;
};

struct fstridpair {
	int			id;
	char			*str;
};

struct fstrfile {
	ht_object_stream	*f;
	strnode			*root;
	FILEOFS			table_pos;
};

fstrfile		fstrfiles[1];
int			fstrfilesmax=0;
int       	fstrid=0;
fstridpair     *fstrs;

void fsinit(ht_object_stream *f)
{
/*	fstrfiles[0].root = NULL;
	fstrfiles[0].f = f;
	fstrfiles[0].table_pos = f->stream->tell();
	f->put_int_hex(0, sizeof(STREAMOFS), "string_pos");*/
}

int fstrinsert(strnode **p, char *s)
{
/*	if (!*p) {
		*p = (strnode *)smalloc(sizeof(strnode));
		(*p)->id = fstrid;
		(*p)->str = s;
		(*p)->left = NULL;
		(*p)->right = NULL;
		return fstrid++;
	} else {
		int i = strcmp(s, (*p)->str);
		if (i>0) {
			return fstrinsert(&(*p)->right, s);
		} else if (i==0) {
			return (*p)->id;
		} else {
			return fstrinsert(&(*p)->left, s);
		}
	}*/
	return 0;
}

void fstrput(ht_object_stream *f, char *s)
{
/*	int	i=fstrinsert(&fstrfiles[0].root, s);
	f->put_int_dec(i, sizeof i, "str_id");*/
}

void fstrget(ht_object_stream *f, char **p)
{
/*	int		id;
	f->read(&id, sizeof(id));*/
//	*p = "(unresolved string)";		// for now
}

void dofstrwrite(strnode *p, ht_object_stream *f)
{
/*	if (p) {
		dofstrwrite(p->left, f);
		f->put_int_dec(p->id, sizeof p->id, "id");
		byte length = strlen(p->str);
		f->put_int_dec(length, sizeof length, "len");
		if (length) f->put_binary(p->str, length, "string");
		dofstrwrite(p->right, f);
	}*/
}


void fstrflush(ht_object_stream *f)
{
/*	f->put_separator();
	STREAMOFS pos = f->stream->tell();
	f->stream->seek(fstrfiles[0].table_pos);
	f->put_int_hex(pos, sizeof pos, "string_pos");
	f->stream->seek(pos);
	f->put_int_dec(fstrid, sizeof fstrid, "string_count");
	dofstrwrite(fstrfiles[0].root, f);
	fstrid = 0;*/
}


void fidqsort(fstridpair *fstrs, int l, int r)
{
/*	int i=l,j=r;
	fstridpair *x = (fstrs + (l + r) / 2);
	int id = x->id;
	fstridpair y;
	do {
		while ((fstrs+i)->id < id) i++;
		while (id < (fstrs+j)->id) j++;
		if (i <= j) {
			y = *(fstrs+i);
			*(fstrs+i) = *(fstrs+j);
			*(fstrs+j) = y;
			i++;
			j--;
		}
	} while (i <= j);
	if (l < j) fidqsort(fstrs, l, j);
	if (i < r) fidqsort(fstrs, i, r);*/
}

void fstrload(ht_object_stream *f)
{
/*	int		count, i, id;
	byte 	length;
	char     	*s;
	STREAMOFS	pos, oldpos;

	f->read(&pos, sizeof pos);
	oldpos = f->tell();
	f->seek(pos);
	f->read(&count, sizeof count);
	fstrs = (fstridpair *)smalloc(count*sizeof(fstridpair));
	for(i=0; i<count; i++) {
		f->read(&id, sizeof id);
		f->read(&length, sizeof length);
		s = (char *)smalloc(length+1);
		if (length) f->read(s, length);
		s[length] = 0;
		(fstrs+i)->id = id;
		(fstrs+i)->str = s;
	}
	fidqsort(fstrs, 0, count-1);

	f->seek(oldpos);*/
}

void fstrdone()
{
	delete fstrs;
}
